=== modified file 'NEWS'
--- NEWS	2009-05-28 22:48:45 +0000
+++ NEWS	2009-04-16 21:49:48 +0000
@@ -4,18 +4,13 @@
 dev [future]
 ---------------
 
-    - Add bug links in revision informations (Alexandre Garnier, #314052)
-
-    - Make sure that binary files aren't annotated. (Martin Albisetti,
-      #258848)
-
     - Loggerhead now serves bzr branches over HTTP and exposes the URL
       to branch them. Addresses bug #240577. (Jonathan Lange)
 
     - Leading blank lines in commit messages no longer result in an
       empty summary. (Colin Watson)
 
-    - Added optional syntax highlighting to annotate view using
+    - Added syntax highlighting to annotate view using
       python-pygments.  Partially addresses bug #306631. (Peter Bui)
 
     - Convert newlines in commit messages to HTML line breaks for
@@ -23,102 +18,36 @@
       Bui)
 
     - serve-branches now errors if run behind a proxy without
-      paste.deploy installed. (Michael Hudson)
+      paste.deploy installed.
 
     - Loggerhead should now handle file and directory names that need
       URL escaping without crashing.
 
     - The start-loggerhead script properly sets the wsgi.url_scheme
-      from the server.webpath option. (neror, #260547)
+      from the server.webpath option. (neror)
 
     - The revision page defaults to unified style again, and can
-      convert to a side-by-side view using JavaScript. (Michael Hudson)
-
-    - Clean up and improve performance of the annotate view. (Michael
-      Hudson)
-
-    - Finish converting JavaScript from MooTools to YUI 3. (Michael
-      Hudson)
-
-    - Improve compatibility with IE 6. (Michael Hudson)
+      convert to a side-by-side view using Javascript.
 
     - Leading blank lines in commit messages no longer result in an
       empty summary. (Colin Watson)
 
-    - Clip long lines in side-by-side diff view. (Michael Hudson,
-      #334837)
-
     - The user-confusing "next" and "previous" links now read "older"
-      and "newer" respectively. (Michael Hudson, #297930)
-
-    - The annotate view now contains line number anchors. (Michael
-      Hudson)
-
-    - Fix inventory pages using "//" in links. (Michael Hudson, #329668)
-
-    - Fix problems viewing files and directories containing spaces and
-      other funny characters. (Peter Bui)
+      and "newer" respectively.
+
+    - The annotate view now contains line number anchors.
+
+    - The annotate view does syntax highlighting using the "pygments"
+      library.  (Peter Bui)
 
     - Changelog messages are now displayed with newlines preserved.
-      (Peter Bui, #273688)
-
-    - Offer a link to see the full file diffs for a file path. (Michael
-      Hudson, #333797)
-
-    - Fix annotate error caused by Pygments stripping trailing
-      whitespace. (Michael Hudson, #338762)
-
-    - Loggerhead can be installed as a Bazaar plugin and run by
-      'bzr serve --http'. (Martin Pool)
-
-    - Load parts of the changelog and revision pages via XMLHttpRequest
-      to improve performance. This adds a dependency on simplejson or
-      json. Partially addresses bug #253950. (Michael Hudson)
-
-    - Various improvements to the animation JavaScript. (Michael Hudson)
-
-    - Fix HTML content of source files being displayed unescaped when
-      Pygments was unavailable. (Michael Hudson, #344970)
-
-    - Fix serve-branches's path argument. (Michael Hudson, #353230)
+      (Peter Bui)
 
     - serve-branches now has an option, --use-cdn, to load YUI from
       Yahoo!'s CDN. (Matt Nordhoff)
 
-    - Fix certain race conditions for loading bzr-search. (Robert
-      Collins, #334250)
-
-    - Fix errors when using serve-branches --log-folder or --user-dirs.
-      (It was calling config.get_option() incorrectly.) (Matt Nordhoff,
-      bug #361238)
-
-    - Move some caching from RAM to the disk, and other caching and
-      memory usage improvements. (Michael Hudson)
-
-    - Add a --cache-dir option to serve-branches to choose where to
-      place the SQL cache, and only create one temporary SQL dir per
-      process. (Matt Nordhoff, #358322)
-
-    - Replace homebrew memory profiling code with Dozer. (Paul Hummer)
-
-    - Use the branch's public_branch as the default suggested URL to
-      branch from (Matt Nordhoff, #369767)
-
-    - Fix a file descriptor leak (Matt Nordhoff, #370845)
-
-    - Use transport API internally, so it is possible to specify a remote 
-      URL to serve-branches. (Jelmer Vernooij, #371787)
-
-    - Fix internal server errors when using start-loggerhead. (Matt
-      Nordhoff, #375948)
-
-    - Fix annotating non-UTF-8 files when Pygments is disabled. (Matt
-      Nordhoff, #376957)
-
-    - Fix 'bzr serve --http' errors. (Matt Nordhoff, #377551)
-
-    - Fix serving branches over HTTP. (Matt Nordhoff, Jelmer Vernooij,
-      #380026)
+    - Fix bug #361238 (serve-branches was calling config.get_option()
+      incorrectly and failing). (Matt Nordhoff)
 
 1.10 [22Dec2008]
 ---------------

=== modified file '__init__.py'
--- __init__.py	2009-05-27 07:23:03 +0000
+++ __init__.py	2009-04-30 10:39:05 +0000
@@ -26,7 +26,7 @@
 
 """Loggerhead web viewer for Bazaar branches.
 
-This provides a new option "--http" to the "bzr serve" command, that 
+This provides a new option "--http" to the "bzr serve" command, that
 starts a web server to browse the contents of a branch.
 """
 
@@ -36,74 +36,53 @@
     import bzrlib
     from bzrlib.api import require_any_api
 
-    require_any_api(bzrlib, [(1, 11, 0), (1, 13, 0), (1, 15, 0)])
+    require_any_api(bzrlib, [(1, 11, 0), (1, 13, 0)])
+
+    # TODO: This should provide a new type of server that can be used by bzr
+    # serve, maybe through a registry, rather than overriding the command.  Though
+    # maybe we should keep the wrapper to work with older bzr releases, at least
+    # for a bit.
 
     # NB: Normally plugins should lazily load almost everything, but this
     # seems reasonable to have in-line here: bzrlib.commands and options are
     # normally loaded, and the rest of loggerhead won't be loaded until serve
     # --http is run.
-        
-    # transport_server_registry was added in bzr 1.16. When we drop support for
-    # older releases, we can remove the code to override cmd_serve.
-
-    try:
-        from bzrlib.transport import transport_server_registry
-    except ImportError:
-        transport_server_registry = None
-
-    DEFAULT_HOST = '0.0.0.0'
+
+    import bzrlib.builtins
+    from bzrlib.commands import get_cmd_object, register_command
+    from bzrlib.option import Option
+
+    _original_command = get_cmd_object('serve')
+
     DEFAULT_PORT = 8080
-    HELP = ('Loggerhead web-based code viewer and server. (default port: %d)' %
-            (DEFAULT_PORT,))
-
-    def serve_http(transport, host=None, port=None, inet=None):
-        # loggerhead internal code will try to 'import loggerhead', so
-        # let's put it on the path
-        import os.path, sys
-        sys.path.append(os.path.dirname(__file__))
-
-        from loggerhead.apps.transport import BranchesFromTransportRoot
-        from loggerhead.config import LoggerheadConfig
-        from paste.httpexceptions import HTTPExceptionHandler
-        from paste.httpserver import serve
-        if host is None:
-            host = DEFAULT_HOST
-        if port is None:
-            port = DEFAULT_PORT
-        argv = ['--host', host, '--port', str(port), transport.base]
-        config = LoggerheadConfig(argv)
-        app = BranchesFromTransportRoot(transport, config)
-        app = HTTPExceptionHandler(app)
-        serve(app, host=host, port=port)
-
-    if transport_server_registry is not None:
-        transport_server_registry.register('http', serve_http, help=HELP)
-    else:
-        import bzrlib.builtins
-        from bzrlib.commands import get_cmd_object, register_command
-        from bzrlib.option import Option
-
-        _original_command = get_cmd_object('serve')
-
-        class cmd_serve(bzrlib.builtins.cmd_serve):
-            __doc__ = _original_command.__doc__
-
-            takes_options = _original_command.takes_options + [
-                Option('http', help=HELP)]
-
-            def run(self, *args, **kw):
-                if 'http' in kw:
-                    from bzrlib.transport import get_transport
-                    path = kw.get('directory', '.')
-                    port = kw.get('port', DEFAULT_PORT)
-                    # port might be an int already...
-                    if isinstance(port, basestring) and ':' in port:
-                        host, port = port.split(':')
-                    else:
-                        host = DEFAULT_HOST
-                    transport = get_transport(path)
-                    serve_http(transport, host, port)
+
+    class cmd_serve(bzrlib.builtins.cmd_serve):
+        __doc__ = _original_command.__doc__
+
+        takes_options = _original_command.takes_options + [
+            Option('http',
+                help='Run an http (Loggerhead) server to browse code, '
+                    'by default on port %s.' % DEFAULT_PORT)]
+
+        def run(self, *args, **kw):
+            if 'http' in kw:
+                # loggerhead internal code will try to 'import loggerhead', so
+                # let's put it on the path
+                import os.path, sys
+                sys.path.append(os.path.dirname(__file__))
+
+                from loggerhead.apps.filesystem import BranchesFromFileSystemRoot
+                from paste.httpexceptions import HTTPExceptionHandler
+                from paste.httpserver import serve
+                a = HTTPExceptionHandler(BranchesFromFileSystemRoot('.'))
+                port = kw.get('port', DEFAULT_PORT)
+                # port might be an int already...
+                if isinstance(port, basestring) and ':' in port:
+                    host, port = port.split(':')
                 else:
-                    super(cmd_serve, self).run(*args, **kw)
+                    host = '0.0.0.0'
+                serve(a, host=host, port=port)
+            else:
+                super(cmd_serve, self).run(*args, **kw)
 
-        register_command(cmd_serve)
+    register_command(cmd_serve)

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2009-05-27 16:21:06 +0000
+++ loggerhead/apps/branch.py	2009-04-30 10:27:43 +0000
@@ -70,7 +70,7 @@
         qs = []
         for k, v in kw.iteritems():
             if v is not None:
-                qs.append('%s=%s'%(k, urllib.quote(v)))
+                qs.append('%s=%s' % (k, urllib.quote(v)))
         qs = '&'.join(qs)
         return request.construct_url(
             self._environ, script_name=self._url_base,
@@ -109,7 +109,7 @@
         change = h.get_changes([h.last_revid])[0]
         return change.date
 
-    def public_branch_url(self):
+    def branch_url(self):
         return self.branch.get_config().get_user_option('public_branch')
 
     def app(self, environ, start_response):
@@ -119,16 +119,7 @@
             self._static_url_base = self._url_base
         self._environ = environ
         if self.served_url is _DEFAULT:
-            public_branch = self.public_branch_url()
-            if public_branch is not None:
-                self.served_url = public_branch
-            else:
-                # Loggerhead only supports serving .bzr/ on local branches, so
-                # we shouldn't suggest something that won't work.
-                if self.branch.base.startswith('file://'):
-                    self.served_url = self.url([])
-                else:
-                    self.served_url = None
+            self.served_url = self.url([])
         path = request.path_info_pop(environ)
         if not path:
             raise httpexceptions.HTTPMovedPermanently(

=== modified file 'loggerhead/apps/config.py'
--- loggerhead/apps/config.py	2009-05-13 13:14:04 +0000
+++ loggerhead/apps/config.py	2008-12-15 21:23:24 +0000
@@ -108,17 +108,20 @@
                 friendly_name = history.get_config().get_nickname()
                 if friendly_name is None:
                     friendly_name = view_name
-            branch_url = self._get_branch_url(view, view_config, view_name)
-            description = self._get_description(view, view_config, history)
             self.view_data_by_name[view_name] = {
                 'branch_path': folder,
-                'config': view_config,
-                'description': description,
+                'args': (view_name, view_config, self.graph_cache),
+                'description': self._get_description(view,
+                                                     view_config,
+                                                     history),
+                '_src_folder': folder,
+                '_view_config': view_config,
                 'friendly_name': friendly_name,
-                'graph_cache': self.graph_cache,
                 'name': view_name,
-                'served_url': branch_url,
                 }
+            branch_url = self._get_branch_url(view, view_config, view_name)
+            if branch_url is not None:
+                self.view_data_by_name[view_name]['branch_url'] = branch_url
             self.view_names.append(view_name)
         finally:
             b.unlock()
@@ -129,13 +132,12 @@
             return None
         view_data = view_data.copy()
         branch_path = view_data.pop('branch_path')
-        description = view_data.pop('description')
-        name = view_data.pop('name')
+        args = view_data.pop('args')
         b = bzrlib.branch.Branch.open(branch_path)
         b.lock_read()
-        view = BranchWSGIApp(b, **view_data)
-        view.description = description
-        view.name = name
+        view = BranchWSGIApp(b, *args)
+        for k in view_data:
+            setattr(view, k, view_data[k])
         return view
 
     def call(self, environ, start_response):

=== renamed file 'loggerhead/apps/transport.py' => 'loggerhead/apps/filesystem.py'
--- loggerhead/apps/transport.py	2009-05-25 01:03:25 +0000
+++ loggerhead/apps/filesystem.py	2009-04-24 10:23:44 +0000
@@ -1,6 +1,8 @@
-"""Serve branches at urls that mimic a transport's file system layout."""
-
-from bzrlib import branch, errors, lru_cache, urlutils
+"""Serve branches at urls that mimic the file system layout."""
+
+import os
+
+from bzrlib import branch, errors, lru_cache
 
 from paste.request import path_info_pop
 from paste import httpexceptions
@@ -12,17 +14,17 @@
 from loggerhead.controllers.directory_ui import DirectoryUI
 
 
-class BranchesFromTransportServer(object):
+class BranchesFromFileSystemServer(object):
 
-    def __init__(self, transport, root, name=None):
-        self.transport = transport
+    def __init__(self, path, root, name=None):
+        self.path = path
         self.root = root
         self.name = name
         self._config = root._config
 
     def app_for_branch(self, branch):
         if not self.name:
-            name = branch._get_nick(local=True)
+            name = branch.get_config().get_nickname()
             is_root = True
         else:
             name = self.name
@@ -45,32 +47,32 @@
             else:
                 name = '/'
             return DirectoryUI(environ['loggerhead.static.url'],
-                               self.transport,
+                               self.path,
                                name)
         else:
-            new_transport = self.transport.clone(segment)
+            new_path = os.path.join(self.path, segment)
             if self.name:
-                new_name = urlutils.join(self.name, segment)
+                new_name = os.path.join(self.name, segment)
             else:
                 new_name = '/' + segment
-            return BranchesFromTransportServer(new_transport, self.root, new_name)
+            return BranchesFromFileSystemServer(new_path, self.root, new_name)
 
     def __call__(self, environ, start_response):
+        if not os.path.isdir(self.path):
+            raise httpexceptions.HTTPNotFound()
         try:
-            b = branch.Branch.open_from_transport(self.transport)
+            b = branch.Branch.open(self.path)
         except errors.NotBranchError:
-            if not self.transport.listable() or not self.transport.has('.'):
-                raise httpexceptions.HTTPNotFound()
             return self.app_for_non_branch(environ)(environ, start_response)
         else:
             return self.app_for_branch(b)(environ, start_response)
 
 
-class BranchesFromTransportRoot(object):
+class BranchesFromFileSystemRoot(object):
 
-    def __init__(self, transport, config):
+    def __init__(self, folder, config):
         self.graph_cache = lru_cache.LRUCache(10)
-        self.transport = transport
+        self.folder = folder
         self._config = config
 
     def __call__(self, environ, start_response):
@@ -82,25 +84,18 @@
         elif environ['PATH_INFO'] == '/favicon.ico':
             return favicon_app(environ, start_response)
         elif '/.bzr/' in environ['PATH_INFO']:
-            # TODO: Use something here that uses the transport API 
-            # rather than relying on the local filesystem API.
-            try:
-                path = urlutils.local_path_from_url(self.transport.base)
-            except errors.InvalidURL:
-                raise httpexceptions.HTTPNotFound()
-            else:
-                app = urlparser.make_static(None, path)
-                return app(environ, start_response)
+            app = urlparser.make_static(None, self.folder)
+            return app(environ, start_response)
         else:
-            return BranchesFromTransportServer(
-                self.transport, self)(environ, start_response)
-
-
-class UserBranchesFromTransportRoot(object):
-
-    def __init__(self, transport, config):
+            return BranchesFromFileSystemServer(
+                self.folder, self)(environ, start_response)
+
+
+class UserBranchesFromFileSystemRoot(object):
+
+    def __init__(self, folder, config):
         self.graph_cache = lru_cache.LRUCache(10)
-        self.transport = transport
+        self.folder = folder
         self._config = config
         self.trunk_dir = config.get_option('trunk_dir')
 
@@ -117,10 +112,10 @@
             # segments starting with ~ are user branches
             if path_info.startswith('/~'):
                 segment = path_info_pop(environ)
-                new_transport = self.transport.clone(segment[1:])
-                return BranchesFromTransportServer(
-                    new_transport, self, segment)(environ, start_response)
+                new_path = os.path.join(self.folder, segment[1:])
+                return BranchesFromFileSystemServer(
+                    new_path, self, segment)(environ, start_response)
             else:
-                new_transport = self.transport.clone(self.trunk_dir)
-                return BranchesFromTransportServer(
-                    new_transport, self)(environ, start_response)
+                new_path = os.path.join(self.folder, self.trunk_dir)
+                return BranchesFromFileSystemServer(
+                    new_path, self)(environ, start_response)

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2009-05-02 14:01:05 +0000
+++ loggerhead/changecache.py	2009-04-24 10:30:15 +0000
@@ -44,7 +44,6 @@
     # To avoid races around creating the database, we create the db in
     # a temporary file and rename it into the ultimate location.
     fd, temp_path = tempfile.mkstemp(dir=os.path.dirname(filename))
-    os.close(fd)
     con = dbapi2.connect(temp_path)
     cur = con.cursor()
     cur.execute(init_sql)

=== modified file 'loggerhead/config.py'
--- loggerhead/config.py	2009-06-02 13:26:49 +0000
+++ loggerhead/config.py	2009-04-30 10:27:43 +0000
@@ -21,7 +21,7 @@
         use_cdn=False,
         sql_dir=None,
         )
-    parser.add_option("--user-dirs", action="store_true", dest="user_dirs",
+    parser.add_option("--user-dirs", action="store_true",
                       help="Serve user directories as ~user.")
     parser.add_option("--trunk-dir", metavar="DIR",
                       help="The directory that contains the trunk branches.")
@@ -31,18 +31,17 @@
     parser.add_option("--host", dest="user_host",
                       help="Host Loggerhead should listen on.")
     parser.add_option('--memory-profile', action='store_true',
-                      dest='memory_profile',
-                      help='Profile the memory usage using Dozer.')
+                      help='Profile the memory usage using heapy.')
     parser.add_option("--prefix", dest="user_prefix",
                       help="Specify host prefix.")
-    parser.add_option("--profile", action="store_true", dest="profile",
+    parser.add_option("--profile", action="store_true",
                       help="Generate callgrind profile data to "
                         "%d-stats.callgrind on each request.")
-    parser.add_option("--reload", action="store_true", dest="reload",
+    parser.add_option("--reload", action="store_true",
                       help="Restarts the application when changing python"
                            " files. Only used for development purposes.")
-    parser.add_option('--log-folder', dest="log_folder",
-                      type=str, help="The directory to place log files in.")
+    parser.add_option('--log-folder',
+                      help="The directory to place log files in.")
     parser.add_option("--version", action="store_true", dest="show_version",
                       help="Print the software version and exit")
     parser.add_option('--use-cdn', action='store_true',
@@ -55,11 +54,9 @@
 class LoggerheadConfig(object):
     '''A configuration object.'''
 
-    def __init__(self, argv=None):
-        if argv is None:
-            argv = sys.argv[1:]
+    def __init__(self):
         self._parser = command_line_parser()
-        self._options, self._args = self._parser.parse_args(argv)
+        self._options, self._args = self._parser.parse_args(sys.argv[1:])
 
         sql_dir = self.get_option('sql_dir')
         if sql_dir is None:
@@ -82,4 +79,3 @@
     def arg_count(self):
         '''Return the number of args from the option parser.'''
         return len(self._args)
-

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2009-05-16 06:05:56 +0000
+++ loggerhead/controllers/annotate_ui.py	2009-03-18 19:34:07 +0000
@@ -23,7 +23,6 @@
 
 import bzrlib.errors
 import bzrlib.textfile
-import bzrlib.osutils
 
 from paste.httpexceptions import HTTPBadRequest, HTTPServerError
 
@@ -49,17 +48,8 @@
 
         file_name = os.path.basename(self._history.get_path(revid, file_id))
 
-        file_text = tree.get_file_text(file_id)
-        encoding = 'utf-8'
-        try:
-            file_text = file_text.decode(encoding)
-        except UnicodeDecodeError:
-            encoding = 'iso-8859-15'
-            file_text = file_text.decode(encoding)
-
-        file_lines = bzrlib.osutils.split_lines(file_text)
-
-        try:
+        try:
+            file_lines = tree.get_file_lines(file_id)
             bzrlib.textfile.check_text_lines(file_lines)
         except bzrlib.errors.BinaryFile:
                 # bail out; this isn't displayable text
@@ -68,7 +58,7 @@
                                      change=util.Container())
         else:
             if highlight is not None:
-                hl_lines = highlight(file_name, file_text, encoding)
+                hl_lines = highlight(file_name, ''.join(file_lines))
                 hl_lines.extend([u''] * (len(file_lines) - len(hl_lines)))
             else:
                 hl_lines = map(cgi.escape, file_lines)

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2009-03-17 22:38:57 +0000
+++ loggerhead/controllers/changelog_ui.py	2009-04-30 10:39:05 +0000
@@ -98,7 +98,7 @@
             'navigation': navigation,
             'filter_file_id': filter_file_id,
             'start_revid': start_revid,
-            'viewing_from': (orig_start_revid is not None) and 
+            'viewing_from': (orig_start_revid is not None) and
                             (orig_start_revid != history.last_revid),
             'query': query,
             'search_failed': search_failed,

=== modified file 'loggerhead/controllers/directory_ui.py'
--- loggerhead/controllers/directory_ui.py	2009-05-28 13:56:43 +0000
+++ loggerhead/controllers/directory_ui.py	2008-12-05 18:52:44 +0000
@@ -18,9 +18,9 @@
 
 import datetime
 import logging
-import stat
+import os
 
-from bzrlib import branch, errors
+from bzrlib import branch
 
 from loggerhead import util
 from loggerhead.controllers import TemplatedBranchView
@@ -48,7 +48,7 @@
 
     template_path = 'loggerhead.templates.directory'
 
-    def __init__(self, static_url_base, transport, name):
+    def __init__(self, static_url_base, path, name):
 
         class _branch(object):
             context_url = 1
@@ -58,26 +58,23 @@
                 return self._static_url_base + path
         self._branch = _branch
         self._history_callable = lambda:None
+        self._path = path
         self._name = name
         self._static_url_base = static_url_base
-        self.transport = transport
         self.log = logging.getLogger('')
 
     def get_values(self, path, kwargs, response):
-        listing = [d for d in self.transport.list_dir('.')
-                   if not d.startswith('.')]
+        listing = [d for d in os.listdir(self._path)
+                   if not d.startswith('.')
+                   and os.path.isdir(os.path.join(self._path, d))]
         listing.sort(key=lambda x: x.lower())
         dirs = []
         parity = 0
         for d in listing:
+            p = os.path.join(self._path, d)
             try:
-                b = branch.Branch.open_from_transport(self.transport.clone(d))
+                b = branch.Branch.open(p)
             except:
-                try:
-                    if not stat.S_ISDIR(self.transport.stat(d).st_mode):
-                        continue
-                except errors.NoSuchFile:
-                    continue
                 b = None
             dirs.append(DirEntry(d, parity, b))
             parity = 1 - parity

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2009-04-29 19:55:16 +0000
+++ loggerhead/controllers/revision_ui.py	2009-03-19 19:04:40 +0000
@@ -95,18 +95,6 @@
 
         h.add_branch_nicks(change)
 
-        if '.' in change.revno:
-            # Walk "down" though the merge-sorted graph until we find a
-            # revision with merge depth 0: this is the revision that merged
-            # this one to mainline.
-            ri = self._history._rev_info
-            i = self._history._rev_indices[change.revid]
-            while ri[i][0][2] > 0:
-                i += 1
-            merged_in = ri[i][0][3]
-        else:
-            merged_in = None
-
         # Directory Breadcrumbs
         directory_breadcrumbs = (
             util.directory_breadcrumbs(
@@ -128,7 +116,6 @@
             'filter_file_id': filter_file_id,
             'util': util,
             'history': h,
-            'merged_in': merged_in,
             'navigation': navigation,
             'query': query,
             'remember': remember,

=== modified file 'loggerhead/highlight.py'
--- loggerhead/highlight.py	2009-05-16 06:03:47 +0000
+++ loggerhead/highlight.py	2009-03-06 13:19:38 +0000
@@ -24,13 +24,20 @@
 DEFAULT_PYGMENT_STYLE = 'colorful'
 
 
-def highlight(path, text, encoding, style=DEFAULT_PYGMENT_STYLE):
+def highlight(path, text, style=DEFAULT_PYGMENT_STYLE):
     """
     Returns a list of highlighted (i.e. HTML formatted) strings.
     """
 
     formatter = HtmlFormatter(style=style, nowrap=True, classprefix='pyg-')
 
+    encoding = 'utf-8'
+    try:
+        text = text.decode(encoding)
+    except UnicodeDecodeError:
+        encoding = 'iso-8859-15'
+        text = text.decode(encoding)
+
     try:
         lexer = guess_lexer_for_filename(path, text[:1024], encoding=encoding)
     except (ClassNotFound, ValueError):

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2009-05-28 22:48:45 +0000
+++ loggerhead/history.py	2009-04-30 10:27:43 +0000
@@ -31,31 +31,29 @@
 import bisect
 import datetime
 import logging
+import marshal
 import re
 import textwrap
 import threading
+from StringIO import StringIO
 
 from loggerhead import search
 from loggerhead import util
 from loggerhead.wholehistory import compute_whole_history_data
 
-import bzrlib
 import bzrlib.branch
 import bzrlib.delta
-import bzrlib.diff
 import bzrlib.errors
 import bzrlib.lru_cache
 import bzrlib.progress
 import bzrlib.revision
-import bzrlib.textfile
-import bzrlib.tsort
 import bzrlib.ui
 
 # bzrlib's UIFactory is not thread-safe
 uihack = threading.local()
 
 
-class ThreadSafeUIFactory (bzrlib.ui.SilentUIFactory):
+class ThreadSafeUIFactory(bzrlib.ui.SilentUIFactory):
 
     def nested_progress_bar(self):
         if getattr(uihack, '_progress_bar_stack', None) is None:
@@ -129,6 +127,7 @@
         return len(self.revid_list)
 
 class FileChangeReporter(object):
+
     def __init__(self, old_inv, new_inv):
         self.added = []
         self.modified = []
@@ -212,7 +211,7 @@
         self._cache[key] = (revid, data)
 
 
-class History (object):
+class History(object):
     """Decorate a branch to provide information for rendering.
 
     History objects are expected to be short lived -- when serving a request
@@ -232,6 +231,9 @@
         parents of this revision.
     :ivar _rev_indices: A dictionary mapping each revision id to the index of
         the information about it in _rev_info.
+    :ivar _full_history: A list of all revision ids in the ancestry of the
+        branch, in merge-sorted order.  This is a bit silly, and shouldn't
+        really be stored on the instance...
     :ivar _revno_revid: A dictionary mapping stringified revnos to revision
         ids.
     """
@@ -264,15 +266,19 @@
             update_missed_caches()
 
         if self._rev_indices is not None:
+            self._full_history = []
             self._revno_revid = {}
             for ((_, revid, _, revno_str, _), _, _) in self._rev_info:
                 self._revno_revid[revno_str] = revid
+                self._full_history.append(revid)
         else:
+            self._full_history = []
             self._revno_revid = {}
             self._rev_indices = {}
             for ((seq, revid, _, revno_str, _), _, _) in self._rev_info:
                 self._rev_indices[revid] = seq
                 self._revno_revid[revno_str] = revid
+                self._full_history.append(revid)
 
     def __init__(self, branch, whole_history_data_cache, file_cache=None,
                  revinfo_disk_cache=None, cache_key=None):
@@ -316,7 +322,7 @@
         revid in revid_list.
         """
         if revid_list is None:
-            revid_list = [r[0][1] for r in self._rev_info]
+            revid_list = self._full_history
         revid_set = set(revid_list)
         revid = start_revid
 
@@ -348,9 +354,9 @@
             w = self._branch.repository.weave_store.get_weave(
                     file_id, self._branch.repository.get_transaction())
             w_revids = w.versions()
-            revids = [r for r in self._rev_indices if r in w_revids]
+            revids = [r for r in self._full_history if r in w_revids]
         except AttributeError:
-            possible_keys = [(file_id, revid) for revid in self._rev_indices]
+            possible_keys = [(file_id, revid) for revid in self._full_history]
             get_parent_map = self._branch.repository.texts.get_parent_map
             # We chunk the requests as this works better with GraphIndex.
             # See _filter_revisions_touching_file_id in bzrlib/log.py
@@ -681,7 +687,6 @@
             'comment': revision.message,
             'comment_clean': [util.html_clean(s) for s in message],
             'parents': revision.parent_ids,
-            'bugs': [bug.split()[0] for bug in revision.properties.get('bugs', '').splitlines()],
         }
         return util.Container(entry)
 
@@ -727,8 +732,8 @@
             text_changes: list((filename, file_id)),
         """
         repo = self._branch.repository
-        if bzrlib.revision.is_null(old_revid) or \
-               bzrlib.revision.is_null(new_revid):
+        if (bzrlib.revision.is_null(old_revid) or
+            bzrlib.revision.is_null(new_revid)):
             old_tree, new_tree = map(
                 repo.revision_tree, [old_revid, new_revid])
         else:

=== modified file 'loggerhead/middleware/profile.py'
--- loggerhead/middleware/profile.py	2009-04-01 22:50:25 +0000
+++ loggerhead/middleware/profile.py	2009-04-30 10:27:53 +0000
@@ -1,11 +1,11 @@
 '''Profiling middleware for paste.'''
-import cgi
+
 import logging
 import sys
 import threading
 
 from bzrlib.lsprof import profile
-from guppy import hpy
+
 
 class LSProfMiddleware(object):
     '''Paste middleware for profiling with lsprof.'''
@@ -33,5 +33,3 @@
             return ret
         finally:
             self.lock.release()
-
-

=== modified file 'loggerhead/search.py'
--- loggerhead/search.py	2009-04-17 01:50:05 +0000
+++ loggerhead/search.py	2009-04-17 03:38:04 +0000
@@ -17,6 +17,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
+
 _mod_index = None
 def import_search():
     global errors, _mod_index, FileTextHit, RevisionHit

=== modified file 'loggerhead/static/css/annotate.css'
--- loggerhead/static/css/annotate.css	2009-03-01 20:57:52 +0000
+++ loggerhead/static/css/annotate.css	2009-04-30 10:39:05 +0000
@@ -4,7 +4,7 @@
 	border:1px solid #d2d2d2;
 }
 .annoLine, .annoRev, .annoComm, .annoCont {
-	border:none;	
+	border:none;
 }
 .annoLine {
 	width:37px;

=== modified file 'loggerhead/static/css/diff.css'
--- loggerhead/static/css/diff.css	2009-05-30 17:40:05 +0000
+++ loggerhead/static/css/diff.css	2009-02-26 20:55:46 +0000
@@ -31,7 +31,7 @@
     width:493px;
     margin:0px 0px 5px 0px;
 }
-.information, .committer, .timer, .mfrom, .mto, .revid, .bug {
+.information, .committer, .timer, .mfrom, .mto, .revid {
     clear:both;
     margin:0px;
     padding:0px 0px 2px 18px;
@@ -65,14 +65,6 @@
 .mto {
     background:url(../images/ico_mergeto.gif) no-repeat top left;
 }
-.bug {
-    padding:1px 0px 0px 18px;
-    margin:0px 10px 5px 0px;
-    float:left;
-    clear:none;
-    display:inline;
-    background:url(../images/ico_bug.png) no-repeat top left;
-}
 /**/
 #loggerheadCont p.expand, #loggerheadCont p.expand a, #loggerheadCont p.expand a:link, #loggerheadCont p.expand a:visited, #loggerheadCont p.expand a:hover {
     color:#0f6b97;

=== modified file 'loggerhead/static/css/files.css'
--- loggerhead/static/css/files.css	2009-05-28 22:48:45 +0000
+++ loggerhead/static/css/files.css	2009-01-23 20:53:40 +0000
@@ -1,5 +1,5 @@
 /*Info Box*/
-.information, .committer, .timer, .mfrom, .mto, .revid, .bug {
+.information, .committer, .timer, .mfrom, .mto, .revid {
 	float:left;
 	margin:0px 10px 5px 0px;
 	padding:0px 0px 2px 18px;
@@ -39,6 +39,3 @@
     width:100%;
     position:relative;
 }
-.bug {
-	background:url(../images/ico_bug.png) no-repeat top left;
-}

=== modified file 'loggerhead/static/css/global.css'
--- loggerhead/static/css/global.css	2009-03-05 22:56:59 +0000
+++ loggerhead/static/css/global.css	2009-04-30 10:39:05 +0000
@@ -180,7 +180,7 @@
 }
 #loggerheadCont p.expand, #loggerheadCont p.expand a, #loggerheadCont p.expand a:link, #loggerheadCont p.expand a:visited, #loggerheadCont p.expand a:hover {
 	color:#000;
-	text-decoration:none;	
+	text-decoration:none;
 }
 #loggerheadCont p img {
 	vertical-align:middle;
@@ -192,7 +192,7 @@
 }
 .revnolink a, .revnolink a:visited, .revnolink a:link, .revnolink a:hover {
 	color:#CC6600;
-	text-decoration:none;		
+	text-decoration:none;
 }
 
 /*Log Table*/
@@ -214,7 +214,7 @@
 }
 .blueRow0, .blueRow1 {
 	background:#eef6fa;
-	font:normal 14px/normal sans-serif;	
+	font:normal 14px/normal sans-serif;
 	padding:0px;
 	margin:0px;
 }
@@ -228,7 +228,7 @@
 	border:1px solid #d2d2d2;
 }
 .expandcell, .expcell {
-	width:28px;	
+	width:28px;
 }
 .summarycell, .authorcell, .datecell, .timedate{
   padding: 4px 8px;

=== removed file 'loggerhead/static/images/ico_bug.png'
Binary files loggerhead/static/images/ico_bug.png and loggerhead/static/images/ico_bug.png differ
=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2009-04-28 03:01:54 +0000
+++ loggerhead/templatefunctions.py	2009-04-17 03:38:04 +0000
@@ -13,6 +13,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
+
 import cgi
 import os
 from loggerhead.zptsupport import zpt
@@ -57,12 +58,12 @@
 
 
 @templatefunc
-def revisioninfo(url, branch, entry, file_changes=None, currently_showing=None, merged_in=None):
+def revisioninfo(url, branch, entry, file_changes=None, currently_showing=None):
     from loggerhead import util
     return _pt('revisioninfo').expand(
         url=url, change=entry, branch=branch, util=util,
         file_changes=file_changes, currently_showing=currently_showing,
-        merged_in=merged_in, **templatefunctions)
+        **templatefunctions)
 
 
 @templatefunc

=== modified file 'loggerhead/templates/annotate.pt'
--- loggerhead/templates/annotate.pt	2009-03-06 09:57:54 +0000
+++ loggerhead/templates/annotate.pt	2009-04-30 10:39:05 +0000
@@ -58,7 +58,7 @@
             <td class="annoContTit">Contents</td>
           </tr>
 
-          <tr tal:repeat="line contents" 
+          <tr tal:repeat="line contents"
               tal:attributes="class string:blueRow${line/parity}">
             <td class="annoLine"><a tal:attributes="id string:L${line/lineno}; href string:#L${line/lineno}" tal:content="line/lineno">1</a></td>
             <td class="annoRev">

=== modified file 'loggerhead/templates/browse.pt'
--- loggerhead/templates/browse.pt	2009-05-13 13:14:04 +0000
+++ loggerhead/templates/browse.pt	2009-04-30 10:39:05 +0000
@@ -28,7 +28,7 @@
                   <img tal:attributes="src python:branch.static_url('/static/images/ico_branch.gif')" alt="Branch" />
                 </td>
                 <td class="autcell">
-                    <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name)" 
+                    <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name)"
                        tal:content="view/friendly_name" />
                 </td>
                 <td class="autcell"
@@ -43,12 +43,12 @@
                   </a>
                 </td>
               </tr>
-              <tr tal:condition="view/served_url">
+              <tr tal:condition="view/branch_url">
                 <td class="name">
                 </td>
                 <td class="description url" colspan="2">
-                  <a tal:attributes="href view/served_url"
-                     tal:content="view/served_url" />
+                  <a tal:attributes="href view/branch_url"
+                     tal:content="view/branch_url" />
                 </td>
               </tr>
             </tal:block>

=== modified file 'loggerhead/templates/directory.pt'
--- loggerhead/templates/directory.pt	2008-10-18 00:23:09 +0000
+++ loggerhead/templates/directory.pt	2009-04-30 10:39:05 +0000
@@ -19,7 +19,7 @@
             <th class="datecell">Latest Rev</th>
             <th class="datecell">Last Changed</th>
           </tr>
-          
+
           <tr class="blueRow0" tal:condition="python:name != '/'">
             <td class="icocell">
                 <a href=".."><img tal:attributes="src python:static_url('/static/images/ico_folder_up.gif')" /></a>

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2009-02-10 04:25:11 +0000
+++ loggerhead/templates/inventory.pt	2009-04-30 10:39:05 +0000
@@ -70,7 +70,7 @@
                                              title string:Go to ${file/filename}" />
                     </a>
 
-                 <a tal:attributes="href python:url(['/files', revno_url, file.absolutepath])" 
+                 <a tal:attributes="href python:url(['/files', revno_url, file.absolutepath])"
                                         tal:content="file/filename" class="link"></a>
                  </td>
                  <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
@@ -93,7 +93,7 @@
                         <img tal:attributes="src python:branch.static_url('/static/images/ico_flecha.gif')" alt="Symlink" />
                     </a>
 
-                 <a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])" 
+                 <a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])"
                                         tal:content="file/filename" class="link"></a>
                  </td>
                  <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
@@ -118,7 +118,7 @@
                                              title string:Annotate ${file/filename}"
                              tal:condition="python:file.executable is False" />
                         <!-- Show a different icon id the file executable -->
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_file_modify.gif'); 
+                        <img tal:attributes="src python:branch.static_url('/static/images/ico_file_modify.gif');
                                              title string:Annotate ${file/filename}"
                              tal:condition="python:file.executable is True" alt="File" />
                     </a>

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2009-04-28 03:01:54 +0000
+++ loggerhead/templates/revision.pt	2009-03-31 21:15:48 +0000
@@ -96,7 +96,7 @@
           </ul>
         </tal:we-are-comparing>
 
-        <tal:revision-info replace="structure python:revisioninfo(url, branch, change, file_changes, specific_path, merged_in)" />
+        <tal:revision-info replace="structure python:revisioninfo(url, branch, change, file_changes, specific_path)" />
         <tal:specific-path condition="not:specific_path">
           <p class="expand show_if_js" id="expand_all"><a href="#">
               <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2009-05-30 17:40:05 +0000
+++ loggerhead/templates/revisioninfo.pt	2009-03-19 00:18:46 +0000
@@ -12,16 +12,7 @@
                                href python:url(['/revision', merge_point.revno], clear=1)"
                tal:content="python:revno_with_nick(merge_point)"></a>
         </div>
-        <div class="mto" tal:condition="merged_in">
-          This revision was merged to the branch mainline in
-          <a tal:attributes="href python:url(['/revision', merged_in], clear=1)">revision
-            <tal:b content="merged_in"/></a>.
-        </div>
         <div class="revid" tal:content="string:Revision ID: ${change/revid}"></div>
-        <div class="clear"><!-- --></div>
-        <div class="bug" tal:repeat="bug change/bugs">
-            <a tal:attributes="href bug" tal:content="bug"></a>
-        </div>
         <div class="information" tal:content="structure python:util.fixed_width(change.comment)"></div>
     </div>
     <ul id="list-files" tal:condition="file_changes">

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2009-04-02 20:32:12 +0000
+++ loggerhead/util.py	2009-04-24 05:20:37 +0000
@@ -129,7 +129,7 @@
     return _wrap_with_date_time_title(date, _displaydate(date))
 
 
-class Container (object):
+class Container(object):
     """
     Convert a dict into an object with attributes.
     """
@@ -537,7 +537,7 @@
     _reloader_environ_key = 'PYTHON_RELOADER_SHOULD_RUN'
 
     @classmethod
-    def _turn_sigterm_into_systemexit(self):
+    def _turn_sigterm_into_systemexit(cls):
         """
         Attempts to turn a SIGTERM exception into a SystemExit exception.
         """
@@ -551,26 +551,26 @@
         signal.signal(signal.SIGTERM, handle_term)
 
     @classmethod
-    def is_installed(self):
-        return os.environ.get(self._reloader_environ_key)
+    def is_installed(cls):
+        return os.environ.get(cls._reloader_environ_key)
 
     @classmethod
-    def install(self):
+    def install(cls):
         from paste import reloader
         reloader.install(int(1))
 
     @classmethod
-    def restart_with_reloader(self):
+    def restart_with_reloader(cls):
         """Based on restart_with_monitor from paste.script.serve."""
         print 'Starting subprocess with file monitor'
-        while 1:
+        while True:
             args = [sys.executable] + sys.argv
             new_environ = os.environ.copy()
-            new_environ[self._reloader_environ_key] = 'true'
+            new_environ[cls._reloader_environ_key] = 'true'
             proc = None
             try:
                 try:
-                    self._turn_sigterm_into_systemexit()
+                    cls._turn_sigterm_into_systemexit()
                     proc = subprocess.Popen(args, env=new_environ)
                     exit_code = proc.wait()
                     proc = None
@@ -579,7 +579,7 @@
                     return 1
             finally:
                 if (proc is not None
-                    and hasattr(os, 'kill')):
+                    and getattr(os, 'kill', None) is not None):
                     import signal
                     try:
                         os.kill(proc.pid, signal.SIGTERM)

=== modified file 'loggerhead/wholehistory.py'
--- loggerhead/wholehistory.py	2009-05-18 04:17:11 +0000
+++ loggerhead/wholehistory.py	2009-04-24 10:30:15 +0000
@@ -53,6 +53,7 @@
          graph.iter_ancestry([last_revid]) if value is not None))
 
     _revision_graph = _strip_NULL_ghosts(parent_map)
+    _full_history = []
 
     _rev_info = []
     _rev_indices = {}
@@ -65,6 +66,7 @@
 
     for info in _merge_sort:
         seq, revid, merge_depth, revno, end_of_merge = info
+        _full_history.append(revid)
         revno_str = '.'.join(str(n) for n in revno)
         parents = _revision_graph[revid]
         _rev_indices[revid] = len(_rev_info)

=== modified file 'loggerheadd'
--- loggerheadd	2008-11-24 20:26:26 +0000
+++ loggerheadd	2009-04-30 10:39:05 +0000
@@ -16,9 +16,9 @@
 
 LHUSER=loggerhead
 
-if [ `whoami` = "$LHUSER" ]; then                                                                                   
+if [ `whoami` = "$LHUSER" ]; then
     SUDO=""
-else                                                                                                                
+else
     SUDO="sudo -H -u $LHUSER"
 fi
 

=== modified file 'serve-branches'
--- serve-branches	2009-05-04 20:21:08 +0000
+++ serve-branches	2009-04-29 23:30:35 +0000
@@ -20,15 +20,14 @@
 import sys
 
 from bzrlib.plugin import load_plugins
-from bzrlib.transport import get_transport
 
 from paste import httpserver
 from paste.httpexceptions import HTTPExceptionHandler, HTTPInternalServerError
 from paste.translogger import TransLogger
 
 from loggerhead import __version__
-from loggerhead.apps.transport import (
-    BranchesFromTransportRoot, UserBranchesFromTransportRoot)
+from loggerhead.apps.filesystem import (
+    BranchesFromFileSystemRoot, UserBranchesFromFileSystemRoot)
 from loggerhead.config import LoggerheadConfig
 from loggerhead.util import Reloader
 from loggerhead.apps.error import ErrorHandlerApp
@@ -49,9 +48,9 @@
     else:
         path = '.'
 
-    load_plugins()
-
-    transport = get_transport(path)
+    if not os.path.isdir(path):
+        print "%s is not a directory" % path
+        sys.exit(1)
 
     if config.get_option('trunk_dir') and not config.get_option('user_dirs'):
         print "--trunk-dir is only valid with --user-dirs"
@@ -67,9 +66,9 @@
         if not config.get_option('trunk_dir'):
             print "You didn't specify a directory for the trunk directories."
             sys.exit(1)
-        app = UserBranchesFromTransportRoot(transport, config)
+        app = UserBranchesFromFileSystemRoot(path, config)
     else:
-        app = BranchesFromTransportRoot(transport, config)
+        app = BranchesFromFileSystemRoot(path, config)
 
     # setup_logging()
     logging.basicConfig()
@@ -135,6 +134,8 @@
     else:
         host = config.get_option('user_host')
 
+    load_plugins()
+
     httpserver.serve(app, host=host, port=port)
 
 

=== modified file 'setup.py' (properties changed: +x to -x)
--- setup.py	2009-06-02 22:10:00 +0000
+++ setup.py	2008-11-20 16:55:47 +0000
@@ -34,9 +34,7 @@
     packages = ["loggerhead",
                 "loggerhead/apps",
                 "loggerhead/controllers",
-                "loggerhead/templates",
-                "bzrlib.plugins.loggerhead"],
-    package_dir={'bzrlib.plugins.loggerhead':'.'},
+                "loggerhead/templates"],
     package_data = {"loggerhead": ["templates/*.pt",
                                    "static/css/*.css",
                                    "static/javascript/*.js",

=== modified file 'start-loggerhead'
--- start-loggerhead	2009-02-19 01:24:20 +0000
+++ start-loggerhead	2009-04-18 06:30:47 +0000
@@ -17,7 +17,6 @@
 
 
 import logging
-import logging.handlers
 from optparse import OptionParser
 import os
 import sys
@@ -32,7 +31,7 @@
 
 from loggerhead import daemon
 from loggerhead.apps.config import Root
-from loggerhead.trace import make_handler, setup_logging
+from loggerhead.trace import setup_logging
 from loggerhead.apps.error import ErrorHandlerApp
 
 

